using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Serialization;

namespace Wave
{
    [CreateAssetMenu(fileName = "SpawnWave", menuName = "Spawn/Wave", order = 0)]
    public class SpawnWaveSO : ScriptableObject
    {
        [SerializeField] private List<SpawnPackSO> packs;
        [SerializeField] private SpawnDistribution distribution;
        [SerializeField] [Min(10)] private float radius;
        [SerializeField] [Min(0)] private float packRadius;
        [SerializeField] [Min(0)] private float timeBetweenSpawns;
        [SerializeField] [Min(0)] private float timeBetweenPacks;
        [SerializeField] [Min(0)] private float timeToComplete;
        
        
        public IReadOnlyCollection<SpawnPackSO> Packs => packs;
        public SpawnDistribution Distribution => distribution;
        public float Radius => radius;
        public float PackRadius => packRadius;
        public float TimeBetweenSpawns => timeBetweenSpawns;
        public float TimeBetweenPacks => timeBetweenPacks;
        public float TimeToComplete => timeToComplete;
    }
}